Index: admin/js/jsToolBar/popup_posts.js
===================================================================
--- admin/js/jsToolBar/popup_posts.js	(revision 0)
+++ admin/js/jsToolBar/popup_posts.js	(revision 0)
@@ -0,0 +1,16 @@
+$(function() {
+	$('#link-insert-cancel').click(function() {
+		window.close();
+	});
+	
+	$('#form-entries tr>td.maximal>a').click(function() {
+		// Get post_id
+		var tb = window.opener.the_toolbar;
+		var data = tb.elements.link.data;
+		
+		data.href = tb.stripBaseURL($(this).attr('title'));
+		
+		tb.elements.link.fncall[tb.mode].call(tb);
+		window.close();
+	});
+});
Index: admin/js/meta-editor.js
===================================================================
--- admin/js/meta-editor.js	(revision 3880)
+++ admin/js/meta-editor.js	(revision 0)
@@ -1,303 +1,273 @@
-/*global $, dotclear */
-'use strict';
-
 //~ metaEditor & metaEditor.prototype should go to the core.
-function metaEditor(target, meta_field, meta_type, meta_options) {
-  this.target = target;
-  this.meta_field = meta_field;
-  this.meta_type = meta_type;
-
-  // options
-  meta_options = meta_options || {};
-  this.meta_url = meta_options.meta_url || this.meta_url;
-  this.list_type = meta_options.list_type || this.list_type;
-  this.text_confirm_remove = meta_options.text_confirm_remove || this.text_confirm_remove;
-  this.text_add_meta = meta_options.text_add_meta || this.text_add_meta;
-  this.text_choose = meta_options.text_choose || this.text_choose;
-  this.text_all = meta_options.text_all || this.text_all;
-  this.text_separation = meta_options.text_separation || this.text_separation;
-}
+function metaEditor(target,meta_field,meta_type) {
+	this.target = target;
+	this.meta_field = meta_field;
+	this.meta_type = meta_type;
+};
 
 metaEditor.prototype = {
-  meta_url: '',
-  text_confirm_remove: 'Are you sure you want to remove this %s?',
-  text_add_meta: 'Add a %s to this entry',
-  text_choose: 'Choose from list',
-  text_all: 'all',
-  text_separation: 'Separate each %s by comas',
-  list_type: 'more',
-
-  target: null,
-  meta_type: null,
-  meta_dialog: null,
-  meta_field: null,
-  submit_button: null,
-  post_id: false,
-
-  service_uri: 'services.php',
-
-  displayMeta: function(type, post_id) {
-    this.meta_type = type;
-    this.post_id = post_id;
-    this.target.empty();
-
-    this.meta_dialog = $('<input type="text" class="ib" />');
-    this.meta_dialog.attr('title', this.text_add_meta.replace(/%s/, this.meta_type));
-    this.meta_dialog.attr('id', 'post_meta_input');
-    // Meta dialog input
-    this.meta_dialog.keypress(function(evt) { // We don't want to submit form!
-      if (evt.keyCode == 13) {
-        This.addMeta(this.value);
-        return false;
-      }
-      return true;
-    });
-
-    const This = this;
-
-    this.submit_button = $('<input type="button" value="ok" class="ib meta-helper" />');
-    this.submit_button.click(function() {
-      const v = This.meta_dialog.val();
-      This.addMeta(v);
-      return false;
-    });
-
-    this.addMetaDialog();
-
-    if (this.post_id == false) {
-      this.target.append(this.meta_field);
-    }
-    this.displayMetaList();
-  },
-
-  displayMetaList: function() {
-    let li;
-    if (this.meta_list == undefined) {
-      this.meta_list = $('<ul class="metaList"></ul>');
-      this.target.prepend(this.meta_list);
-    }
-
-    if (this.post_id == false) {
-      const meta = this.splitMetaValues(this.meta_field.val());
-
-      this.meta_list.empty();
-      for (let i = 0; i < meta.length; i++) {
-        li = $('<li>' + meta[i] + '</li>');
-        const a_remove = $('<button type="button" class="metaRemove meta-helper"><img src="images/trash.png" alt="remove" /></button>');
-        a_remove.get(0).caller = this;
-        a_remove.get(0).meta_id = meta[i];
-        a_remove.click(function() {
-          this.caller.removeMeta(this.meta_id);
-          return false;
-        });
-        li.prepend('&nbsp;').prepend(a_remove);
-        this.meta_list.append(li);
-      }
-    } else {
-      const This = this;
-      const params = {
-        f: 'getMeta',
-        metaType: this.meta_type,
-        sortby: 'metaId,asc',
-        postId: this.post_id
-      };
-
-      $.get(this.service_uri, params, function(data) {
-        data = $(data);
-
-        if (data.find('rsp').attr('status') != 'ok') {
-          return;
-        }
-
-        This.meta_list.empty();
-        data.find('meta').each(function() {
-          const meta_id = $(this).text();
-          li = $('<li><a href="' + This.meta_url + $(this).attr('uri') + '">' + meta_id + '</a></li>');
-          const a_remove = $('<button type="button" class="metaRemove meta-helper"><img src="images/trash.png" alt="remove" /></button>');
-          a_remove.get(0).caller = This;
-          a_remove.get(0).meta_id = meta_id;
-          a_remove.click(function() {
-            this.caller.removeMeta(this.meta_id);
-            return false;
-          });
-          li.prepend('&nbsp;').prepend(a_remove);
-          This.meta_list.append(li);
-        });
-      });
-    }
-  },
-
-  addMetaDialog: function() {
-
-    if (this.submit_button == null) {
-      this.target.append($('<p></p>').append(this.meta_dialog));
-    } else {
-      this.target.append($('<p></p>').append(this.meta_dialog).append(' ').append(this.submit_button));
-    }
-
-    if (this.text_separation != '') {
-      this.target.append($('<p></p>').addClass('form-note').append(this.text_separation.replace(/%s/, this.meta_type)));
-    }
-
-    this.showMetaList(this.list_type, this.target);
-
-  },
-
-  showMetaList: function(list_type, target) {
-    const params = {
-      f: 'getMeta',
-      metaType: this.meta_type,
-      sortby: 'metaId,asc'
-    };
-
-    if (list_type == 'more') {
-      params.limit = '30';
-    }
-
-    const This = this;
-
-    $.get(this.service_uri, params, function(data) {
-
-      const pl = $('<p class="addMeta"></p>');
-
-      $(target).find('.addMeta').remove();
-
-      if ($(data).find('meta').length > 0) {
-        pl.empty();
-
-        $(data).find('meta').each(function(i) {
-          const meta_link = $('<button type="button" class="metaItem meta-helper">' + $(this).text() + '</button>');
-          meta_link.get(0).meta_id = $(this).text();
-          meta_link.click(function() {
-            const v = This.splitMetaValues(This.meta_dialog.val() + ',' + this.meta_id);
-            This.meta_dialog.val(v.join(','));
-            return false;
-          });
-
-          if (i > 0) {
-            pl.append(', ');
-          }
-          pl.append(meta_link);
-        });
-
-        if (list_type == 'more') {
-          const a_more = $('<button type="button" class="button metaGetMore meta-helper"></button>');
-          a_more.append(This.text_all + String.fromCharCode(160) + String.fromCharCode(187));
-          a_more.click(function() {
-            This.showMetaList('more-all', target);
-            return false;
-          });
-          pl.append(', ').append(a_more);
-        }
-
-        if (list_type != 'more-all') {
-          pl.addClass('hide');
-
-          const pa = $('<p></p>');
-          target.append(pa);
-
-          const a = $(`<button type="button" class="button metaGetList meta-helper">${This.text_choose}</button>`);
-          a.click(function() {
-            $(this).parent().next().removeClass('hide');
-            $(this).remove();
-            return false;
-          });
-
-          pa.append(a);
-        }
-
-        target.append(pl);
-
-      } else {
-        pl.empty();
-      }
-    });
-  },
-
-  addMeta: function(str) {
-    str = this.splitMetaValues(str).join(',');
-    if (this.post_id == false) {
-      str = this.splitMetaValues(this.meta_field.val() + ',' + str);
-      this.meta_field.val(str);
-
-      this.meta_dialog.val('');
-      this.displayMetaList();
-    } else {
-      const params = {
-        xd_check: dotclear.nonce,
-        f: 'setPostMeta',
-        postId: this.post_id,
-        metaType: this.meta_type,
-        meta: str
-      };
-
-      const This = this;
-      $.post(this.service_uri, params, function(data) {
-        if ($(data).find('rsp').attr('status') == 'ok') {
-          This.meta_dialog.val('');
-          This.displayMetaList();
-        } else {
-          window.alert($(data).find('message').text());
-        }
-      });
-    }
-  },
-
-  removeMeta: function(meta_id) {
-    if (this.post_id == false) {
-      let meta = this.splitMetaValues(this.meta_field.val());
-      for (let i = 0; i < meta.length; i++) {
-        if (meta[i] == meta_id) {
-          meta.splice(i, 1);
-          break;
-        }
-      }
-      this.meta_field.val(meta.join(','));
-      this.displayMetaList();
-    } else {
-      const text_confirm_msg = this.text_confirm_remove.replace(/%s/, this.meta_type);
-
-      if (window.confirm(text_confirm_msg)) {
-        const This = this;
-        const params = {
-          xd_check: dotclear.nonce,
-          f: 'delMeta',
-          postId: this.post_id,
-          metaId: meta_id,
-          metaType: this.meta_type
-        };
-
-        $.post(this.service_uri, params, function(data) {
-          if ($(data).find('rsp').attr('status') == 'ok') {
-            This.displayMetaList();
-          } else {
-            window.alert($(data).find('message').text());
-          }
-        });
-      }
-    }
-  },
-
-  splitMetaValues: function(str) {
-    function inArray(needle, stack) {
-      for (var i = 0; i < stack.length; i++) {
-        if (stack[i] == needle) {
-          return true;
-        }
-      }
-      return false;
-    }
-
-    let res = [];
-    let v = str.split(',');
-    v.sort();
-    for (let i = 0; i < v.length; i++) {
-      v[i] = v[i].replace(/^\s*/, '').replace(/\s*$/, '');
-      if (v[i] != '' && !inArray(v[i], res)) {
-        res.push(v[i]);
-      }
-    }
-    res.sort();
-    return res;
-  }
+	meta_url: '',
+	text_confirm_remove: 'Are you sure you want to remove this %s?',
+	text_add_meta: 'Add a %s to this entry',
+	text_choose: 'Choose from list',
+	text_all: 'all',
+	text_separation: 'Separate each %s by comas',
+	
+	target: null,
+	meta_type: null,
+	meta_dialog: null,
+	meta_field: null,
+	submit_button: null,
+	post_id: false,
+	
+	service_uri: 'services.php',
+	
+	displayMeta: function(type,post_id) {
+		this.meta_type = type;
+		this.post_id = post_id;
+		this.target.empty();
+		
+		this.meta_dialog = $('<input type="text" />');
+		this.meta_dialog.attr('title',this.text_add_meta.replace(/%s/,this.meta_type));
+		this.meta_dialog.attr('id','post_meta_input');
+		// Meta dialog input
+		this.meta_dialog.keypress(function(evt) { // We don't want to submit form!
+			if (evt.keyCode == 13) {
+				This.addMeta(this.value);
+				return false;
+			}
+			return true;
+		});
+		
+		var This = this;
+		
+		this.submit_button = $('<input type="button" value="ok" />');
+		this.submit_button.click(function() {
+			var v = This.meta_dialog.val();
+			This.addMeta(v);
+			return false;
+		});
+		
+		this.addMetaDialog();
+		
+		if (this.post_id == false) {
+			this.target.append(this.meta_field);
+		}
+		this.displayMetaList();
+	},
+	
+	displayMetaList: function() {
+		var li;
+		if (this.meta_list == undefined) {
+			this.meta_list = $('<ul class="metaList"></ul>');
+			this.target.prepend(this.meta_list);
+		}
+		
+		if (this.post_id == false) {
+			var meta = this.splitMetaValues(this.meta_field.val());
+			
+			this.meta_list.empty();
+			for (var i=0; i<meta.length; i++) {
+				li = $('<li>'+meta[i]+'</li>');
+				a_remove = $('<a class="metaRemove" href="#">[x]</a>');
+				a_remove.get(0).caller = this;
+				a_remove.get(0).meta_id = meta[i];
+				a_remove.click(function() {
+					this.caller.removeMeta(this.meta_id);
+					return false;
+				});
+				li.append('&nbsp;').append(a_remove);
+				this.meta_list.append(li);
+			}
+		} else {
+			var This = this;
+			var params = {
+				f: 'getMeta',
+				metaType: this.meta_type,
+				sortby: 'metaId,asc',
+				postId: this.post_id
+			};
+			
+			$.get(this.service_uri,params,function(data) {
+				data = $(data);
+				
+				if (data.find('rsp').attr('status') != 'ok') { return; }
+				
+				This.meta_list.empty();
+				data.find('meta').each(function() {
+					var meta_id = $(this).text();
+					li = $('<li><a href="' + This.meta_url + $(this).attr('uri') + '">'+meta_id+'</a></li>');
+					a_remove = $('<a class="metaRemove" href="#">[x]</a>');
+					a_remove.get(0).caller = This;
+					a_remove.get(0).meta_id = meta_id;
+					a_remove.click(function() {
+						this.caller.removeMeta(this.meta_id);
+						return false;
+					});
+					li.append('&nbsp;').append(a_remove);
+					This.meta_list.append(li);
+				});
+			});
+		}
+	},
+	
+	addMetaDialog: function() {
+		var This = this;
+		
+		if (this.submit_button == null) {
+			this.target.append($('<p></p>').append(this.meta_dialog));
+		} else {
+			this.target.append($('<p></p>').append(this.meta_dialog).append(' ').append(this.submit_button));
+		}
+		
+		// View meta list
+		var a = $('<a href="#">' + this.text_choose + '</a>');
+		a.click(function() {
+			This.showMetaList(metaEditor.prototype.meta_type,$(this).parent());
+			return false;
+		});
+		if (this.text_separation != '') {
+			this.target.append($('<p></p>').addClass('form-note').append(this.text_separation.replace(/%s/,this.meta_type)));
+		}
+		this.target.append($('<p></p>').append(a));
+	},
+	
+	showMetaList: function(type,target) {
+		target.empty();
+		target.append('...');
+		target.addClass('addMeta');
+		
+		var params = {
+			f: 'getMeta',
+			metaType: this.meta_type,
+			sortby: 'metaId,asc'
+		};
+		
+		if (type == 'more') {
+			params.limit = '30';
+		}
+		
+		var This = this;
+		
+		$.get(this.service_uri,params,function(data) {
+			if ($(data).find('meta').length > 0) {
+				target.empty();
+				var meta_link;
+				
+				$(data).find('meta').each(function(i) {
+					meta_link = $('<a href="#">' + $(this).text() + '</a>');
+					meta_link.get(0).meta_id = $(this).text();
+					meta_link.click(function() {
+						var v = This.splitMetaValues(This.meta_dialog.val() + ',' + this.meta_id);
+						This.meta_dialog.val(v.join(','));
+						return false;
+					});
+					
+					if (i>0) {
+						target.append(', ');
+					}
+					target.append(meta_link);
+				});
+				
+				if (type == 'more') {
+					var a_more = $('<a href="#" class="metaGetMore"></a>');
+					a_more.append(This.text_all + String.fromCharCode(160)+String.fromCharCode(187));
+					a_more.click(function() {
+						This.showMetaList('all',target);
+						return false;
+					});
+					target.append(', ').append(a_more);
+				}
+			} else {
+				target.empty();
+			}
+		});
+	},
+	
+	addMeta: function(str) {
+		str = this.splitMetaValues(str).join(',');
+		if (this.post_id == false) {
+			str = this.splitMetaValues(this.meta_field.val() + ',' + str);
+			this.meta_field.val(str);
+			
+			this.meta_dialog.val('');
+			this.displayMetaList();
+		} else {
+			var params = {
+				xd_check: dotclear.nonce,
+				f: 'setPostMeta',
+				postId: this.post_id,
+				metaType: this.meta_type,
+				meta: str
+			};
+			
+			var This = this;
+			$.post(this.service_uri,params,function(data) {
+				if ($(data).find('rsp').attr('status') == 'ok') {
+					This.meta_dialog.val('');
+					This.displayMetaList();
+				} else {
+					alert($(data).find('message').text());
+				}
+			});
+		}
+	},
+	
+	removeMeta: function(meta_id) {
+		if (this.post_id == false) {
+			var meta = this.splitMetaValues(this.meta_field.val());
+			for (var i=0; i<meta.length; i++) {
+				if (meta[i] == meta_id) {
+					meta.splice(i,1);
+					break;
+				}
+			}
+			this.meta_field.val(meta.join(','));
+			this.displayMetaList();
+		} else {
+			var text_confirm_msg = this.text_confirm_remove.replace(/%s/,this.meta_type);
+			
+			if (window.confirm(text_confirm_msg)) {
+				var This = this;
+				var params = {
+					xd_check: dotclear.nonce,
+					f: 'delMeta',
+					postId: this.post_id,
+					metaId: meta_id,
+					metaType: this.meta_type
+				};
+				
+				$.post(this.service_uri,params,function(data) {
+					if ($(data).find('rsp').attr('status') == 'ok') {
+						This.displayMetaList();
+					} else {
+						alert($(data).find('message').text());
+					}
+				});
+			}
+		}
+	},
+	
+	splitMetaValues: function(str) {
+		function inArray(needle,stack) {
+			for (var i=0; i<stack.length; i++) {
+				if (stack[i] == needle) {
+					return true;
+				}
+			}
+			return false;
+		}
+		
+		var res = new Array();
+		var v = str.split(',');
+		v.sort();
+		for (var i=0; i<v.length; i++) {
+			v[i] = v[i].replace(/^\s*/,'').replace(/\s*$/,'');
+			if (v[i] != '' && !inArray(v[i],res)) {
+				res.push(v[i]);
+			}
+		}
+		res.sort();
+		return res;
+	}
 };
Index: admin/js/tool-man/cookies.js
===================================================================
--- admin/js/tool-man/cookies.js	(revision 0)
+++ admin/js/tool-man/cookies.js	(revision 0)
@@ -0,0 +1,34 @@
+/* Copyright (c) 2005 Tim Taylor Consulting (see LICENSE.txt)
+
+based on http://www.quirksmode.org/js/cookies.html
+*/
+
+ToolMan._cookieOven = {
+	
+	set : function(name, value, expirationInDays) {
+		if (expirationInDays) {
+			var date = new Date()
+			date.setTime(date.getTime() + (expirationInDays * 24 * 60 * 60 * 1000))
+			var expires = "; expires=" + date.toGMTString()
+		} else {
+			var expires = ""
+		}
+		document.cookie = name + "=" + value + expires + "; path=/"
+	},
+	
+	get : function(name) {
+		var namePattern = name + "="
+		var cookies = document.cookie.split(';')
+		for(var i = 0, n = cookies.length; i < n; i++) {
+			var c = cookies[i]
+			while (c.charAt(0) == ' ') c = c.substring(1, c.length)
+			if (c.indexOf(namePattern) == 0)
+				return c.substring(namePattern.length, c.length)
+		}
+		return null
+	},
+	
+	eraseCookie : function(name) {
+		createCookie(name, "", -1)
+	}
+};
Index: admin/js/tool-man/coordinates.js
===================================================================
--- admin/js/tool-man/coordinates.js	(revision 0)
+++ admin/js/tool-man/coordinates.js	(revision 0)
@@ -0,0 +1,154 @@
+/* Copyright (c) 2005 Tim Taylor Consulting (see LICENSE.txt) */
+
+/* FIXME: assumes position styles are specified in 'px' */
+
+ToolMan._coordinatesFactory = {
+	
+	create : function(x, y) {
+		// FIXME: Safari won't parse 'throw' and aborts trying to do anything with this file
+		//if (isNaN(x) || isNaN(y)) throw "invalid x,y: " + x + "," + y
+		return new _ToolManCoordinate(this, x, y)
+	},
+	
+	origin : function() {
+		return this.create(0, 0)
+	},
+	
+	/*
+	 * FIXME: Safari 1.2, returns (0,0) on absolutely positioned elements
+	 */
+	topLeftPosition : function(element) {
+		var left = parseInt(ToolMan.css().readStyle(element, "left"))
+		var left = isNaN(left) ? 0 : left
+		var top = parseInt(ToolMan.css().readStyle(element, "top"))
+		var top = isNaN(top) ? 0 : top
+		
+		return this.create(left, top)
+	},
+	
+	bottomRightPosition : function(element) {
+		return this.topLeftPosition(element).plus(this._size(element))
+	},
+	
+	topLeftOffset : function(element) {
+		var offset = this._offset(element) 
+		
+		var parent = element.offsetParent
+		while (parent) {
+			offset = offset.plus(this._offset(parent))
+			parent = parent.offsetParent
+		}
+		return offset
+	},
+	
+	bottomRightOffset : function(element) {
+		return this.topLeftOffset(element).plus(
+				this.create(element.offsetWidth, element.offsetHeight))
+	},
+	
+	scrollOffset : function() {
+		if (window.pageXOffset) {
+			return this.create(window.pageXOffset, window.pageYOffset)
+		} else if (document.documentElement) {
+			return this.create(
+					document.body.scrollLeft + document.documentElement.scrollLeft, 
+					document.body.scrollTop + document.documentElement.scrollTop)
+		} else if (document.body.scrollLeft >= 0) {
+			return this.create(document.body.scrollLeft, document.body.scrollTop)
+		} else {
+			return this.create(0, 0)
+		}
+	},
+	
+	clientSize : function() {
+		if (window.innerHeight >= 0) {
+			return this.create(window.innerWidth, window.innerHeight)
+		} else if (document.documentElement) {
+			return this.create(document.documentElement.clientWidth,
+					document.documentElement.clientHeight)
+		} else if (document.body.clientHeight >= 0) {
+			return this.create(document.body.clientWidth,
+					document.body.clientHeight)
+		} else {
+			return this.create(0, 0)
+		}
+	},
+	
+	/**
+	 * mouse coordinate relative to the window (technically the
+	 * browser client area) i.e. the part showing your page
+	 *
+	 * NOTE: in Safari the coordinate is relative to the document
+	 */
+	mousePosition : function(event) {
+		event = ToolMan.events().fix(event)
+		return this.create(event.clientX, event.clientY)
+	},
+	
+	/**
+	 * mouse coordinate relative to the document
+	 */
+	mouseOffset : function(event) {
+		event = ToolMan.events().fix(event)
+		if (event.pageX >= 0 || event.pageX < 0) {
+			return this.create(event.pageX, event.pageY)
+		} else if (event.clientX >= 0 || event.clientX < 0) {
+			return this.mousePosition(event).plus(this.scrollOffset())
+		}
+	},
+	
+	_size : function(element) {
+	/* TODO: move to a Dimension class */
+		return this.create(element.offsetWidth, element.offsetHeight)
+	},
+	
+	_offset : function(element) {
+		return this.create(element.offsetLeft, element.offsetTop)
+	}
+}
+
+function _ToolManCoordinate(factory, x, y) {
+	this.factory = factory
+	this.x = isNaN(x) ? 0 : x
+	this.y = isNaN(y) ? 0 : y
+}
+
+_ToolManCoordinate.prototype = {
+	toString : function() {
+		return "(" + this.x + "," + this.y + ")"
+	},
+	
+	plus : function(that) {
+		return this.factory.create(this.x + that.x, this.y + that.y)
+	},
+	
+	minus : function(that) {
+		return this.factory.create(this.x - that.x, this.y - that.y)
+	},
+	
+	min : function(that) {
+		return this.factory.create(
+				Math.min(this.x , that.x), Math.min(this.y , that.y))
+	},
+	
+	max : function(that) {
+		return this.factory.create(
+				Math.max(this.x , that.x), Math.max(this.y , that.y))
+	},
+	
+	constrainTo : function (one, two) {
+		var min = one.min(two)
+		var max = one.max(two)
+		
+		return this.max(min).min(max)
+	},
+	
+	distance : function (that) {
+		return Math.sqrt(Math.pow(this.x - that.x, 2) + Math.pow(this.y - that.y, 2))
+	},
+	
+	reposition : function(element) {
+		element.style["top"] = this.y + "px"
+		element.style["left"] = this.x + "px"
+	}
+}
Index: admin/js/tool-man/core.js
===================================================================
--- admin/js/tool-man/core.js	(revision 0)
+++ admin/js/tool-man/core.js	(revision 0)
@@ -0,0 +1,170 @@
+/*
+Copyright (c) 2005 Tim Taylor Consulting <http://tool-man.org/>
+
+Permission is hereby granted, free of charge, to any person obtaining a
+copy of this software and associated documentation files (the "Software"),
+to deal in the Software without restriction, including without limitation
+the rights to use, copy, modify, merge, publish, distribute, sublicense,
+and/or sell copies of the Software, and to permit persons to whom the
+Software is furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included
+in all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
+OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+IN THE SOFTWARE.
+*/
+
+var ToolMan = {
+	events : function() {
+		if (!ToolMan._eventsFactory) throw "ToolMan Events module isn't loaded";
+		return ToolMan._eventsFactory
+	},
+	
+	css : function() {
+		if (!ToolMan._cssFactory) throw "ToolMan CSS module isn't loaded";
+		return ToolMan._cssFactory
+	},
+	
+	coordinates : function() {
+		if (!ToolMan._coordinatesFactory) throw "ToolMan Coordinates module isn't loaded";
+		return ToolMan._coordinatesFactory
+	},
+	
+	drag : function() {
+		if (!ToolMan._dragFactory) throw "ToolMan Drag module isn't loaded";
+		return ToolMan._dragFactory
+	},
+	
+	dragsort : function() {
+		if (!ToolMan._dragsortFactory) throw "ToolMan DragSort module isn't loaded";
+		return ToolMan._dragsortFactory
+	},
+	
+	helpers : function() {
+		return ToolMan._helpers
+	},
+	
+	cookies : function() {
+		if (!ToolMan._cookieOven) throw "ToolMan Cookie module isn't loaded";
+		return ToolMan._cookieOven
+	},
+	
+	junkdrawer : function() {
+		return ToolMan._junkdrawer
+	}
+	
+}
+
+ToolMan._helpers = {
+	map : function(array, func) {
+		for (var i = 0, n = array.length; i < n; i++) func(array[i])
+	},
+	
+	nextItem : function(item, nodeName) {
+		if (item == null) return false;
+		var next = item.nextSibling
+		while (next != null) {
+			if (next.nodeName == nodeName) return next
+			next = next.nextSibling
+		}
+		return null
+	},
+	
+	previousItem : function(item, nodeName) {
+		var previous = item.previousSibling
+		while (previous != null) {
+			if (previous.nodeName == nodeName) return previous
+			previous = previous.previousSibling
+		}
+		return null
+	},
+	
+	moveBefore : function(item1, item2) {
+		var parent = item1.parentNode
+		parent.removeChild(item1)
+		parent.insertBefore(item1, item2)
+	},
+	
+	moveAfter : function(item1, item2) {
+		var parent = item1.parentNode
+		parent.removeChild(item1)
+		parent.insertBefore(item1, item2 ? item2.nextSibling : null)
+	}
+}
+
+/** 
+ * scripts without a proper home
+ *
+ * stuff here is subject to change unapologetically and without warning
+ */
+ToolMan._junkdrawer = {
+	serializeList : function(list) {
+		var items = list.getElementsByTagName("li")
+		var array = new Array()
+		for (var i = 0, n = items.length; i < n; i++) {
+			var item = items[i]
+			
+			array.push(ToolMan.junkdrawer()._identifier(item))
+		}
+		return array.join('|')
+	},
+	
+	inspectListOrder : function(id) {
+		alert(ToolMan.junkdrawer().serializeList(document.getElementById(id)))
+	},
+	
+	restoreListOrder : function(listID) {
+		var list = document.getElementById(listID)
+		if (list == null) return
+		
+		var cookie = ToolMan.cookies().get("list-" + listID)
+		if (!cookie) return;
+		
+		var IDs = cookie.split('|')
+		var items = ToolMan.junkdrawer()._itemsByID(list)
+		
+		for (var i = 0, n = IDs.length; i < n; i++) {
+			var itemID = IDs[i]
+			if (itemID in items) {
+				var item = items[itemID]
+				list.removeChild(item)
+				list.insertBefore(item, null)
+			}
+		}
+	},
+	
+	_identifier : function(item) {
+		var trim = ToolMan.junkdrawer().trim
+		var identifier
+		
+		identifier = trim(item.getAttribute("id"))
+		if (identifier != null && identifier.length > 0) return identifier;
+		
+		identifier = trim(item.getAttribute("itemID"))
+		if (identifier != null && identifier.length > 0) return identifier;
+		
+		// FIXME: strip out special chars or make this an MD5 hash or something
+		return trim(item.innerHTML)
+	},
+	
+	_itemsByID : function(list) {
+		var array = new Array()
+		var items = list.getElementsByTagName('li')
+		for (var i = 0, n = items.length; i < n; i++) {
+			var item = items[i]
+			array[ToolMan.junkdrawer()._identifier(item)] = item
+		}
+		return array
+	},
+	
+	trim : function(text) {
+		if (text == null) return null
+		return text.replace(/^(\s+)?(.*\S)(\s+)?$/, '$2')
+	}
+}
Index: admin/js/tool-man/css.js
===================================================================
--- admin/js/tool-man/css.js	(revision 0)
+++ admin/js/tool-man/css.js	(revision 0)
@@ -0,0 +1,17 @@
+/* Copyright (c) 2005 Tim Taylor Consulting (see LICENSE.txt) */
+
+// TODO: write unit tests
+ToolMan._cssFactory = {
+	readStyle : function(element, property) {
+		if (element.style[property]) {
+			return element.style[property]
+		} else if (element.currentStyle) {
+			return element.currentStyle[property]
+		} else if (document.defaultView && document.defaultView.getComputedStyle) {
+			var style = document.defaultView.getComputedStyle(element, null)
+			return style.getPropertyValue(property)
+		} else {
+			return null
+		}
+	}
+}
